import java.net.*;
import java.io.*;
import java.util.*;

import sun.security.krb5.internal.UDPClient;

public class networkclient {

	private static int numberOfPackets=1;
	
	private static void measurePacketloss(String[] packets){
		for(int i=0;i < packets.length; i++){
			System.out.println(packets[i]);
		}
		
	}
	
	private static void receivePacket(DatagramSocket datagramsock){
		int i = 0;
		byte buffer[] = new byte[1000];
		String received;
		String receivedData[] = new String[numberOfPackets];
		try{
			long starttime = System.currentTimeMillis()-1;
			while(i < numberOfPackets ){
				
				DatagramPacket receivePacket = new DatagramPacket(buffer, buffer.length);
				System.out.println("Recieving Packet");
				
				datagramsock.receive(receivePacket);
				//TODO add time and packet loss measurement
				
				received = new String(receivePacket.getData(), 0, receivePacket.getLength());
				receivedData[i] = received;
				
				System.out.println(received);
				long currenttime = System.currentTimeMillis();
				long millisFromStart = (currenttime - starttime);
				double percentage = i+1;
				percentage = percentage /numberOfPackets;
				percentage = percentage * 100;
				System.out.println("Transferrate = " + i+1 / millisFromStart);
				System.out.println("Packetloss = " + (100 - percentage));
				
				i++;
			}
			measurePacketloss(receivedData);
			
		} catch (SocketException e) {
		
			e.printStackTrace();
		
		}catch (IOException e) {
		
			e.printStackTrace();
	
		}
	}
	
	private static void sendPacket(DatagramSocket datagramsock){
		byte buffer[] = new byte[1000];
		InetAddress address;
		try {
			
			address = InetAddress.getByName("vulcano.informatik.uni-freiburg.de");
			String bytesRequested = ""+ numberOfPackets*1000;
			System.out.println("Bytes Requested: "+ bytesRequested );
			buffer = (bytesRequested + "\n\n").getBytes();
			DatagramPacket sendPacket = new DatagramPacket(buffer, buffer.length, address, 8888);
			System.out.println("Sending Packet...");
			datagramsock.send(sendPacket);
			
		} catch (UnknownHostException e) {
			
			System.out.println("Could not find host vulcano.informatik.uni-freiburg.de!");
			e.printStackTrace();
			
		} catch (IOException e) {
			
			e.printStackTrace();
		}
		
		
	}
	
	private static void udpclient(){

		int port = 6666;
		try {
			
			DatagramSocket datagramsock = new DatagramSocket(port);
			sendPacket(datagramsock);
			receivePacket(datagramsock);
			
		} catch (SocketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
			
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		if(args.length < 1 ){
			System.out.println("Usage: networkclient udp <bytestorecieve> or networkclient tcp");
			System.exit(0);
		}
		else{
		  if(args[0].compareToIgnoreCase("udp") == 0){
			  
			  if(args.length < 2){
				  System.out.println("Usage: networkclient udp <bytestorecieve>");
				  System.exit(0);
			  }
			
		    try {
		    	
			    numberOfPackets = Integer.parseInt(args[1]);
			    
			    
			} catch (NumberFormatException e) {
				System.out.println("Usage: networkclient udp <bytestorecieve>");
				System.exit(0);
			}
			
			  System.out.println("Starting UDP Client");
			  udpclient();
		  }
		}

	}

}
